<?php
/**
 * CodeIgniter
 *
 * An open source application development framework for PHP
 *
 * This content is released under the MIT License (MIT)
 *
 * Copyright (c) 2014 - 2017, British Columbia Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * @package	CodeIgniter
 * @author	EllisLab Dev Team
 * @copyright	Copyright (c) 2008 - 2014, EllisLab, Inc. (https://ellislab.com/)
 * @copyright	Copyright (c) 2014 - 2017, British Columbia Institute of Technology (http://bcit.ca/)
 * @license	http://opensource.org/licenses/MIT	MIT License
 * @link	https://codeigniter.com
 * @since	Version 1.0.0
 * @filesource
 */
defined('BASEPATH') OR exit('Direkter Skriptzugriff ist nicht erlaubt');

$lang['form_validation_required']         = 'Das Feld {field} ist ein Pflichtfeld.';
$lang['form_validation_isset']            = 'Das Feld {field} muss einen Wert enthalten.';
$lang['form_validation_valid_email']      = 'Das Feld {field} muss eine g&uuml;ltige E-Mail-Adresse enthalten.';
$lang['form_validation_valid_emails']     = 'Das Feld {field} kann nur g&uuml;ltige E-Mail-Adressen enthalten.';
$lang['form_validation_valid_url']        = 'Das Feld {field} muss eine g&uuml;ltige Web-Adresse (URL) enthalten.';
$lang['form_validation_valid_ip']         = 'Das Feld {field} muss eine g&uuml;ltige IP enthalten.';
$lang['form_validation_min_length']       = 'Das Feld {field} muss mindestens {param} Zeichen lang sein.';
$lang['form_validation_max_length']       = 'Das Feld {field} darf nicht l&auml;nger als {param} Zeichen lang sein.';
$lang['form_validation_exact_length']     = 'Das Feld {field} muss genau {param} lang sein.';
$lang['form_validation_alpha']            = 'Das Feld {field} darf nur Buchstaben enthalten.';
$lang['form_validation_alpha_numeric']       = 'Das Feld {field} darf nur Buchstaben und/oder Zahlen enthalten.';
$lang['form_validation_alpha_dash']       = 'Das Feld {field} darf nur Buchstaben, Zahlen, Bindestriche und Unterstriche enthalten.';
$lang['form_validation_numeric']          = 'Das Feld {field} darf nur Zahlen enthalten.';
$lang['form_validation_is_numeric']       = 'Das Feld {field} darf nur Zahlen enthalten.';
$lang['form_validation_integer']          = 'Das Feld {field} muss einen ganzzahligen Wert enthalten.';
$lang['form_validation_regex_match']      = 'Das Feld {field} ist nicht im korrekten Format.';
$lang['form_validation_matches']          = 'Das Feld {field} muss mit dem Feld {param} &uuml;bereinstimmen.';
$lang['form_validation_is_unique']        = 'Das Feld {field} muss einen eindeutigen Wert enthalten.';
$lang['form_validation_is_natural']       = 'Das Feld {field} darf nur positive Zahlen enthalten.';
$lang['form_validation_is_natural_no_zero'] = 'Das Feld {field} darf nur Zahlen grö&szlig;er Null enthalten.';
$lang['form_validation_decimal']       = 'Das Feld {field} muss eine Dezimalzahl enthalten.';
$lang['form_validation_less_than']        = 'Das Feld {field} muss eine Zahl kleiner als {param} enthalten.';
$lang['form_validation_less_than_equal_to']  = 'Das Feld {field} muß eine Zahl kleiner als oder gleich {param} enthalten.';
$lang['form_validation_greater_than']     = 'Das Feld {field} muss eine Zahl gr&ouml;&szlig; als {param} enthalten.';
$lang['form_validation_greater_than_equal_to']  = 'Das Feld {field} muss eine Zahl gr&ouml;&szlig; als oder gleich {param} enthalten.';
$lang['form_validation_error_message_not_set']  = 'Kein Zugriff auf eine Fehlermeldung die Ihrem Feldnamen {field} entspricht.';
$lang['form_validation_in_list']    = 'Das Feld {field} muss eines von {param} sein';
